with Interfaces; use Interfaces;

package body CORBA_Repository_Root_AbstractInterfaceDef_Hash is

   P : constant array (0 .. 3) of Natural :=
     (2, 4, 8, 13);

   T1 : constant array (0 .. 3) of Unsigned_8 :=
     (41, 86, 30, 84);

   T2 : constant array (0 .. 3) of Unsigned_8 :=
     (15, 59, 12, 64);

   G : constant array (0 .. 88) of Unsigned_8 :=
     (0, 35, 0, 31, 0, 0, 0, 0, 0, 0, 23, 0, 4, 2, 2, 1, 0, 0, 0, 0, 0, 0,
      0, 0, 36, 28, 12, 11, 1, 0, 0, 15, 26, 0, 0, 23, 0, 0, 19, 6, 0, 0, 0,
      0, 8, 0, 0, 0, 27, 0, 0, 0, 33, 27, 10, 12, 11, 8, 24, 0, 38, 3, 0, 1,
      8, 37, 17, 0, 0, 21, 0, 0, 32, 0, 0, 11, 0, 0, 0, 0, 5, 18, 14, 0, 34,
      1, 20, 42, 30);

   function Hash (S : String) return Natural is
      F : constant Natural := S'First - 1;
      L : constant Natural := S'Length;
      F1, F2 : Natural := 0;
      J : Natural;
   begin
      for K in P'Range loop
         exit when L < P (K);
         J  := Character'Pos (S (P (K) + F));
         F1 := (F1 + Natural (T1 (K)) * J) mod 89;
         F2 := (F2 + Natural (T2 (K)) * J) mod 89;
      end loop;
      return (Natural (G (F1)) + Natural (G (F2))) mod 44;
   end Hash;

end CORBA_Repository_Root_AbstractInterfaceDef_Hash;
